
// set of the defined values used for the data dependence analsysis;
// for most of the files

#define MAXITDATAFLOW 100
// needs to be bigger than real loop, symbols may appear twice.
#define MAXNESTEDLOOP 50  
#define MAXDIMARRAY 7
#define MAXP 100
#define MAXNODE 10000
#define NOARRAYREF 0
#define NO_STEP 10000


//constanteSet.C
#define  UNDEFFLAG     1
#define  NONCONSTFLAG  2
#define  CONSTFLAG     3

//depGraph.C
#define WRONGDEP     0
#define ARRAYDEP     1
#define PRIVATEDEP   2
#define REDUCTIONDEP 3
#define SCALARDEP    4
#define DEPZERO 1
#define DEPGREATER 2
#define DEPLESS 4

//dependence.C
#define OUTDEP    1
#define FLOWDEP   2
#define ANTIDEP   3
#define UNKNOWNDEP 4  

//intrinsic.C
#define  INTRINSIC_DUM  0
#define  INTRINSIC_MAX  1
#define  INTRINSIC_MIN  2
#define  INTRINSIC_ABS  3
#define  INTRINSIC_COS  4
#define  INTRINSIC_SIN  5
#define  INTRINSIC_DFLOAT 6
#define  INTRINSIC_FLOAT 7
#define  INTRINSIC_NUMNODES 8
#define  INTRINSIC_MYNODE    9
#define  INTRINSIC_MOD    10
#define  INTRINSIC_DEXP    11
#define  INTRINSIC_DCOS    12
#define  INTRINSIC_DSIN    13
#define  INTRINSIC_ASIN    14
#define  INTRINSIC_EXP    15
#define  INTRINSIC_DBLE    16
#define  INTRINSIC_LOG10   17
#define  INTRINSIC_AINT    18
#define  INTRINSIC_RANDLC    19
#define  INTRINSIC_INT  20
#define  INTRINSIC_SQRT  21
#define  INTRINSIC_ATAN  22
#define  INTRINSIC_LOG  23
#define  INTRINSIC_ACOS  24
#define  INTRINSIC_SIGN  25
#define  INTRINSIC_REAL  26
#define  INTRINSIC_DIM  27
#define  INTRINSIC_CMPLX  28
#define  INTRINSIC_AIMAG  29
#define  INTRINSIC_DABS  30
#define  INTRINSIC_KCCSHARED  31
#define  INTRINSIC_GSYNC1  32
#define  INTRINSIC_KCCPROCSEQNUM  33
#define  INTRINSIC_LAST 34

#define  STRING_INTRINSIC_DUM  "dummy"
#define  STRING_INTRINSIC_MAX  "max"
#define  STRING_INTRINSIC_MIN  "min"
#define  STRING_INTRINSIC_ABS  "abs"
#define  STRING_INTRINSIC_COS  "cos"
#define  STRING_INTRINSIC_SIN  "sin"
#define  STRING_INTRINSIC_DFLOAT "dfloat"
#define  STRING_INTRINSIC_FLOAT "float"
#define  STRING_INTRINSIC_NUMNODES  "numnodes"
#define  STRING_INTRINSIC_MYNODE    "mynode"
#define  STRING_INTRINSIC_MOD    "mod"
#define  STRING_INTRINSIC_DEXP    "dexp"
#define  STRING_INTRINSIC_DCOS    "dcos"
#define  STRING_INTRINSIC_DSIN    "dsin"
#define  STRING_INTRINSIC_ASIN    "asin"
#define  STRING_INTRINSIC_EXP    "exp"
#define  STRING_INTRINSIC_DBLE    "dble"
#define  STRING_INTRINSIC_LOG10   "log10"
#define  STRING_INTRINSIC_AINT    "aint"
#define  STRING_INTRINSIC_RANDLC    "randlc"
#define  STRING_INTRINSIC_INT  "int"
#define  STRING_INTRINSIC_SQRT  "sqrt"
#define  STRING_INTRINSIC_ATAN  "atan"
#define  STRING_INTRINSIC_LOG  "log"
#define  STRING_INTRINSIC_ACOS  "acos"
#define  STRING_INTRINSIC_SIGN  "sign"
#define  STRING_INTRINSIC_REAL  "real"
#define  STRING_INTRINSIC_DIM  "dim"
#define  STRING_INTRINSIC_CMPLX  "cmplx"
#define  STRING_INTRINSIC_AIMAG  "aimag"
#define  STRING_INTRINSIC_DABS "dabs"
#define  STRING_INTRINSIC_KCCSHARED "kccshared"
#define  STRING_INTRINSIC_GSYNC1 "gsync1"
#define  STRING_INTRINSIC_KCCPROCSEQNUM "kccprocseqnum"

//reductionCode.C
#define UNKNOWREDUCTION 0
#define SADDREDUCTION   2
#define DADDREDUCTION 3
#define IADDREDUCTION 4
#define SMULREDUCTION  5 
#define DMULREDUCTION 6
#define IMULREDUCTION 7
#define SDIVREDUCTION  8 
#define DDIVREDUCTION 9
#define IDIVREDUCTION 10
#define SMAXREDUCTION  11 
#define DMAXREDUCTION 12
#define IMAXREDUCTION 13
#define SMINREDUCTION  14 
#define DMINREDUCTION 15
#define IMINREDUCTION 16

// set.C
#define ALLOCATECHUNKSET  100
#define MAXELEMENT 10000

