#define BUFSIZE 512

typedef struct {
  FILE *fp;
  char dir;  /* r or w */
  int total; /* total chars in buffer */
  int next;  /* next char in buffer */
  char buf[BUFSIZE];
} STREAM;

typedef enum {FALSE, TRUE} BOOLEAN;

STREAM *Sopen(char *path, char *dir);
int Sgetc(STREAM *z);
BOOLEAN Sputc(STREAM *z, char c);
BOOLEAN Sclose(STREAM *z);
