#include <stdio.h>
#include "structs.h"

int GNumProcs = 0;
BAR_GRAPH_NODES *GBarGraph;
FILE *GBreakFile;
extern NAME_LIST *GMatchVarName;
extern ABSTRACT_EVENT *GSelectAbstractEvent;
extern COLLAPSE_NODE *GSelectCollapseNode;
extern int GShowAttribute;
extern ABSTRACT_EVENT *GMatchToShow;
extern LINE_DATA *GLines2Draw;
extern FILE *GTraceFile, *GCommandFile, *GScriptFile;


int get_total_procs()
{
  return GNumProcs;
}

void set_total_procs (int max)
{
  GNumProcs = max;
}

/*
 ************************************************************************
 * FUNCTION(S):   o get_match_variable_name()                           *
 *                o set_match_variable_name()                           *
 * DESCRIPTION:   access functions for the global variable GMatchVarName*
 ************************************************************************
*/

NAME_LIST *get_match_variable_name ()
{
  return GMatchVarName;
}

void set_match_variable_name (NAME_LIST *nl)
{
  GMatchVarName = nl;
}

/*
 ************************************************************************
 * FUNCTION(S):   o get_select_abstract_event()                         *
 *                o set_select_abstract_event()                         *
 * DESCRIPTION:   access functions for the global variable:             *
 *                             GSelectAbstractEvent                     *
 ************************************************************************
*/

ABSTRACT_EVENT *get_select_abstract_event()
{
  return GSelectAbstractEvent;
}

void set_select_abstract_event (ABSTRACT_EVENT *ae)
{
  GSelectAbstractEvent = ae;
}

/*
 ************************************************************************
 * FUNCTION(S):   o get_select_collapse_node()                          *
 *                o set_select_collapse_node()                          *
 * DESCRIPTION:   access functions for the global variable:             *
 *                             GSelectCollapseNode                      *
 ************************************************************************
*/

COLLAPSE_NODE *get_select_collapse_node ()
{
  return GSelectCollapseNode;
}

void set_select_collapse_node (COLLAPSE_NODE *cn)
{
  GSelectCollapseNode = cn;
}

/*
 ************************************************************************
 * FUNCTION(S):   o get_show_attribute_flag()                           *
 *                o set_select_attribute_flag()                         *
 * DESCRIPTION:   access functions for the global variable:             *
 *                             GSelectCollapseNode                      *
 ************************************************************************
*/

int get_show_attribute_flag()
{
  return GShowAttribute;
}

void set_show_attribute_flag (int value)
{
  GShowAttribute = 1;
}


FILE *get_trace_file_ptr()
{
  return GTraceFile;
}


void canvas_communication_init()
{
  GBarGraph = NULL;
  GScriptFile = NULL;
  GShowAttribute = 0;
  GSelectAbstractEvent = NULL;
  GSelectCollapseNode = NULL;
  GMatchToShow = NULL;
  GMatchVarName = NULL;
  GLines2Draw = NULL;
}

void file_init()
{
  GCommandFile = fopen("ave.history.commands", "w");
  GBreakFile = fopen("ave.breakpoint.summary", "rw");
  
}


  
