#define WarnIf( cond, message)	\
{if(cond)fprintf(stderr,"Warning (%s:%d): %s\n",__FILE__,__LINE__,(message));}
				/* Warns if condition is true */
#define AbortIf( cond, message)	\
{if(cond){fprintf(stderr,"Error (%s:%d): %s\n",__FILE__,__LINE__,(message));\
	    abort();}}		/* Stops if condition is true */

#define assert(cond)	\
{if(!(cond)){fprintf(stderr,"Assertion failed (%s:%d): %s \n",\
		     __FILE__,__LINE__,#cond); abort();}} 
				/* aborts if condition is false */

