extern LINKED_LIST *allocate_linked_list();
extern void add_node_to_list (LINKED_LIST **ll, void *contents);
extern void delete_node_from_list(LINKED_LIST **head, void *contents);
extern void linked_list_concat (LINKED_LIST **head,  LINKED_LIST *new);
extern int get_size_of_list (LINKED_LIST *ll);
extern void *get_element_from_list (LINKED_LIST *ll, int pos);
extern void apply_transform_on_elements (LINKED_LIST *ll, void (*transform)());
extern LINKED_LIST *compute_new_list 
(LINKED_LIST *ll, void* (*list_maker)(void *, void *), void *);
extern int are_elements_distinct 
(LINKED_LIST *ll, boolean (*match) (void *, void *) );
extern int check_ordered_relation 
  (LINKED_LIST *ll, boolean (*match)(void *, void *));
extern void truncate_linked_list
  (LINKED_LIST *ll, int n);
extern void insert_node_in_list (LINKED_LIST **ll, void *contents, int pos);
extern void remove_all_nodes_from_list (LINKED_LIST *ll);
extern void free_list (LINKED_LIST *ll);
