/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


# define COM_NULL    -1
# define COM_EXCLUDE  0
# define COM_INCLUDE  1
# define COM_MAX      2

# ifndef TRUE
#   define FALSE 0
#   define TRUE  1
# endif

typedef struct
{
  regexp *regexpr;
  char   *regstr;
}
REXP;

# define RNULL ((REXP *) 0)

typedef struct
{
  int child;
  int stmts;
  int op;
}
LIMIT;

# define OP_OR  0
# define OP_AND 1
# define OP_MAX 2

/* extern void *malloc(unsigned size);
extern void *realloc(void *ptr, unsigned size);
*/

# define xalloc(num,type) (type *) malloc((num)*sizeof(type))
# define xrealloc(ptr,num,type) (type *) realloc((ptr),(num)*sizeof(type))

extern int debugMode;
extern LIMIT excl_limit, count_limit;
extern int ignoreInlines;
extern int level_limit;

# define IS_TOO_SMALL 0
# define COUNT_ONLY   1
# define IS_FINE      2
