/* c i d t i d . h
 *
 * A map from (CID,TID) to (void*) 
 */

#ifndef INCLUDED_CIDTID
#define INCLUDED_CIDTID

#ifdef __cplusplus
extern "C" {
#endif

#include "proginfo.h"

typedef struct snz_cidtid_t snz_cidtid_t;

snz_cidtid_t *snz_alloc_cidtid( struct snz_proginfo_t *pi );
void snz_free_cidtid( snz_cidtid_t *map );
void snz_cidtid_insert( snz_cidtid_t *map, int cid, int tid, void *data );
void *snz_cidtid_lookup( snz_cidtid_t *map, int cid, int tid );

#ifdef __cplusplus
}
#endif

#endif /* ifndef INCLUDED_CIDTID */

/* eof */
