/* t u l i p . c
 * $Id: tulip.c,v 1.1 1996/05/01 20:10:14 lth Exp $
 *
 * 'Tulip' RTS specific support for SPMD. 
 */

#define SERVER_SIDE

#include <stdlib.h>
#include "message.h"
#include "server-types.h"

extern int MyNodeNumber;
extern int MyTotalNodes;

void _snz_spmd_terminate_thread( void )
{
  exit( 1 );
}

int _snz_spmd_nodenumber( void )
{
  return MyNodeNumber;
}

snz_time_t _snz_get_time( void )
{
  return 0;
}

int _snz_total_nodes()
{
  return MyTotalNodes;
}

void *_snz_allocbuf( int len )
{
  void *p = malloc( len );
  if (p == 0)
    snz_perror_panic( "malloc" );
  return p;
}

void _snz_freebuf( void *buf )
{
  free( buf );
}

/* eof */
