/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/



class Real{
  REAL data;
 public:
  Real(){};
  Real(Real * x){data = x->data;};
  Real(double x){data = x;};
  void setValue(int i, double x){}; // for compat. with fb dist. array 
  void load(double x){ data = x;}; 
  double value(){ return data; };
  Real operator +(Real &rhs){
      Real x;
      x.data = this->data + rhs.data;
      return x;};
  Real operator *(Real &rhs){
      Real x;
      x.data = this->data * rhs.data;
      return x;};
  Real operator -(Real &rhs){
      Real x;
      x.data = this->data - rhs.data;
      return x;};
  Real operator -(){
      Real x;
      x.data = -this->data;
      return x;};
  Real operator /(Real &rhs){
      Real x;
      x.data = this->data / rhs.data;
      return x;};
  Real &operator =(Real &rhs){
      this->data = rhs.data;
      return *this;};
  Real &operator +=(Real &rhs){
      this->data += rhs.data;
      return *this;};
  void allocData(int s){};
  double dot(Real &arg1){ return this->data*arg1.data;};
  void print(){printf("%f ", this->data); }
};

