#define MSG_C
#include "Trace.h"
#include "TaskLibIncludes.h"
#include "SimulatorIncludes.h"

Msg_c::Msg_c()
{
  MsgCat = REAL;
  FromNodeId = 0;
  ToNodeId = 0;
  MsgType = NOTAMSG;
  MsgSize = 0;
  MsgPar = 0;
  NextMsg = (Msg_c *)NULL;
  Suspend(_PackStartupTime);
}

Msg_c::Msg_c(int cat, int type, int size, int from, int to, int par)
{
  MsgCat = cat;
  FromNodeId = from;
  ToNodeId = to;
  MsgType = type;
  MsgSize = size;
  MsgPar = par;
  NextMsg = (Msg_c *)NULL;
  if (cat == REAL)
    Suspend(_BytePackTime * size + _PackStartupTime);
}

#undef MSG_C
