#ifndef MSGQUEUE_H
#define MSGQUEUE_H

#define MAXMSG 100

class Msg_c;

class MsgQueue_c {
 private:
  Semaphore Mutex;
  Semaphore Empty;
  Semaphore Full;
  int QCount;
  Msg_c *Front;
  Msg_c *End;
 public:
  MsgQueue_c(int MaxMsg);
  int AddMsg(Msg_c *Msg);
  int AddMsgNoBlock(Msg_c *Msg);
  Msg_c *GetMsg();
  Msg_c *GetMsgNoBlock();
};

#ifndef MSGQUEUE_C
#endif

#endif

