
cccccccccccccccccccccccccccccccccccccccccccccccccc
ccc   The main program has a common block it creates
ccc   several processes, each which has a copy of 
ccc   the same common block.  The values in each 
ccc   common block are changed and then the program
ccc   verifies that each process still has independent
ccc   common block.  
cccccccccccccccccccccccccccccccccccccccccccccccccc
      program test_common
      process common /fm_block/v1,v2, v3
      real  v1,v2,v3
      process common /fm_block/v1,v2, v3
      real  v1,v2,v3
      parameter (nodes = 5)
      inport (real ) previous_node(nodes)
      outport (real ) next_node(nodes)
      processors (nodes)
      do  i = 1,nodes
         channel(OUT=next_node(mod (i,nodes) + 1), IN=previous_node(i))
      enddo
      v1 = 3.14
      v2 = 2.78
      v3 = 6.30
      check_v1 = v1
      check_v2 = v2
      check_v3 = v3
      processes
         processdo  i = 1,nodes
            process call test_proc(i,previous_node(i),next_node(i)) loca
     +tion(i)
         endprocessdo
      endprocesses
      print *,'INPORTS and OUTPORTS worked.'
      print *,'CHANNEL worked.'
      print *,'SEND and RECEIVE worked.'
      print *,'ENDCHANNEL worked.'
      print *,'PROCESSORS used OK.'
      print *,'LOCATION ran OK.'
      if (v1 .eq. check_v1 .and. v2 .eq. check_v2 .and. v3 .eq. check_v3
     +) then
         print *,'PROCESS COMMON blocks OK.'
      else
         print *,'PROCESS COMMON blocks NOT OK.'
         print *,'In main program, v1: ',v1
         print *,'In main program, v2: ',v2
         print *,'In main program, v3: ',v3
      endif
      end

      process test_proc (id, previous_node, next_node)
      outport (real ) next_node
      inport (real ) previous_node
      real  synch_temp
      integer  the_stat
      process common /fm_block/v1,v2, v3
      real  v1,v2,v3
      process common /fm_block/v1,v2, v3
      real  v1,v2,v3
      parameter (nodes = 5)
      intent(in) id
      if (id .eq. 1) then
         v1 = 1.00 + id
         v2 = 2.00 + id
         v3 = 3.00 + id
         check_v1 = v1
         send(PORT=next_node, IOSTAT=the_stat, ERR=500) v3
         endchannel(PORT=next_node)
         receive(PORT=previous_node, IOSTAT=the_stat, ERR=600, END=700) 
     +synch_temp
50    continue
         receive(PORT=previous_node, END=100) synch_temp
         goto 50
100      if (v1 .ne. check_v1) then
            print *,'PROCESS COMMON blocks NOT OK in processes.'
            print *,'in process, v1: ',v1
            print *,'in process, v2: ',v2
            print *,'in process, v3: ',v3
         endif
      else
         receive(PORT=previous_node, IOSTAT=the_stat, ERR=600, END=700) 
     +synch_temp
150   continue
         receive(PORT=previous_node, END=200) synch_temp
         goto 150
200      v1 = 1.00 + id
         v2 = 2.00 + id
         v3 = 3.00 + id
         send(PORT=next_node, IOSTAT=the_stat, ERR=500) v3
         endchannel(PORT=next_node)
      endif
      return
500   print *,'ERRor detected in send of the value',v3,' from node',id
      print *,'IOSTAT was',the_stat,'.  Terminating.'
      stop
600   print *,'ERRor detected in receive of the value',synch_temp,' from
     + node',id
      print *,'IOSTAT was',the_stat,'.  Terminating.'
      stop
700   print *,'End of channel detected on node',id,' when it should not'
     +
      print *,'have been detected.  IOSTAT was',the_stat,'.  Terminating
     +.'
      stop
      end

