
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc   Create several channels and move an inport to an 
ccc   inport and an outport to an outport.  We use moveport 
ccc   in 2 different contexts, when the port being moved 
ccc   was declared on the current node, and when the port 
ccc   being moved was declared on another node but passed 
ccc   to the current node as a parameter.  After each type 
ccc   of move works a message is printed to that effect.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc  NOTE:  moveport isn't implemented yet so this won't compile.
      program test_moveport
      parameter (n = 2)
      processors (n)
      integer  x,y,z
      inport (integer ) in_local1
      inport (integer ) in_local2
      inport (integer ) in_remote1
      inport (integer ) in_remote2
      inport (integer ) temp_in
      outport (integer ) out_local1
      outport (integer ) out_local2
      outport (integer ) out_remote1
      outport (integer ) out_remote2
      outport (integer ) temp_out
      channel(OUT=out_local1, IN=in_local1)
      channel(OUT=out_local2, IN=in_local2)
      channel(OUT=out_remote1, IN=in_remote1)
      channel(OUT=out_remote2, IN=in_remote2)
      send(PORT=out_local1) 37
      send(PORT=out_local1) 41
      moveport(FROM=in_local1, TO=temp_in)
      receive(PORT=temp_in) x
      receive(PORT=temp_in) y
      if (x .eq. 37 .and. y .eq. 41) then
         print *,'Moveport worked on local inport.'
      else
         print *,'Moveport did not work on local inport.'
         print *,'Should have received 37 and 41.  Instead we received: 
     + ',x,y
      endif
      moveport(FROM=out_local2, TO=temp_out)
      send(PORT=temp_out) 23
      receive(PORT=in_local2) x
      if (x .ne. 23) then
         print *,'Moveport worked on local outport.'
      else
         print *,'Moveport did not work on local outport.'
         print *,'Should have received 23.  Instead we received:  ',x
      endif

ccc   
ccc   Send the integer "5" to the channel with outport Out_remote1
ccc   
      send(PORT=out_remote1) 5
      processes
         process call p1(out_remote1,in_remote1) location(2)
      endprocesses

ccc   
ccc   Send the integer "7" to the channel with outport Out_remote1
ccc   
      send(PORT=out_remote1) 7
      processes
         process call p2(out_remote2,in_remote2) location(2)
      endprocesses
      print *,'About to receive off the port In_remote1 to see if it'
      print *,'migrated back to the master processor.'
      receive(PORT=in_remote1) z
      if (z .ne. 521) then
         print *,'Correct value not received in In(4) after the process'
     +
         print *,'at location(2) ended.  Should have received 521 but '
         print *,'instead received:  ',z
      else
         print *,'Port migrated back correctly to the master node after'
     +
         print *,'it was at location(2).'
      endif
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccc
      process p1 (out, in)
      outport (integer ) out
      inport (integer ) in
      inport (integer ) temp_in
      integer  z
      receive(PORT=in) z
      if (z .ne. 5) then
         print *,'Correct value not received in the channel passed to p1
     +() on'
         print *,'location(2).  Should have received 5 but instead recei
     +ved:',z
      endif
      send(PORT=out) 9
      moveport(FROM=in, TO=temp_in)
      receive(PORT=temp_in) z
      if (z .eq. 9) then
         print *,'Moveport worked correctly on remote inport which was'
         print *,'passed to location(2).'
      else
         print *,'Moveport worked incorrectly on remote inport.  Should 
     +have'
         print *,'received 9 but instead received:  ',z
      endif
      send(PORT=out) 521
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccc
      process p2 (out, in)
      outport (integer ) out
      outport (integer ) temp_out
      inport (integer ) in
      integer  z
      receive(PORT=in) z
      if (z .ne. 7) then
         print *,'Correct value not received in the channel passed to p2
     +() on'
         print *,'location(2).  Should have received 7 but instead recei
     +ved:',z
      endif
      moveport(FROM=out, TO=temp_out)
      send(PORT=temp_out) 11
      receive(PORT=in) z
      if (z .eq. 11) then
         print *,'Moveport worked correctly on remote outport which was'
     +
         print *,'passed to location(2).'
      else
         print *,'Moveport worked incorrectly on remote outport.  Should
     + have'
         print *,'received 11 but instead received:  ',z
      endif
      end

