
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc   Declare a mesh of 4 by 16 processors and create 
ccc   four processes, each with a submachines of 4 by 
ccc   4 processors.  A process is then spawned on each 
ccc   of the processors of each submachine.  If the 
ccc   process block which creates the submachines 
ccc   terminates properly, then the submachines are 
ccc   assumed to have worked properly.  
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
      program test_submachine
      parameter (n = 4)
      parameter (n2 = n * n)
      processors (n,n2)
      inport (integer ) in(n)
      outport (integer ) out(n)
      do  i = 1,n
         channel(OUT=out(mod (i,n) + 1), IN=in(i))
      enddo

ccc   processdo i = 1, N
ccc       call foo(In(i), Out(i)) submachine(1, N*(i-1) + 1)
ccc   enddo
      processes
         process call foo(in(1),out(1)) submachine(1,1)
         process call foo(in(2),out(2)) submachine(1,5)
         process call foo(in(3),out(3)) submachine(1,9)
         process call foo(in(4),out(4)) submachine(1,13)
      endprocesses
      print *,'SUBMACHINE ran OK on a',n,' by',n2,' grid.'
      end


ccccccccccccccccccccccccccccccccccccccc
      process foo (in, out)
      inport (integer ) in
      outport (integer ) out
      parameter (n = 4)
      integer  a
      processors (n,n)
      send(PORT=out) 1
      receive(PORT=in) a
      print *,'in foo.'
      processdo  i = 1,n
         processdo  j = 1,n
            process call compute_something(a + i + j) location(i,j)
         endprocessdo
      endprocessdo
      print *,'out foo.'
      return
      end


ccccccccccccccccccccccccccccccccccccccc
      process compute_something (z)
      intent(in) z
      integer  z
      z = z + 1
      return
      end

