/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/************** Struct for information about Collections *************/
struct INFO_HEAD {
  int    LocalTraversalCount;
  char   *CurrentCollectionTraversal;
  int    type;
  int    number_dimension;
  int    element_size;
  int    nb_element;
  int    dim1size, dim2size, dim3size;
#if defined(_SMRTS_) || defined(_AWE_)
  int    **Where; /* temporary */
#endif
};

/********************* Record for each Collection *******************/
typedef struct {
  struct INFO_HEAD *cinfo;
  tulip_GlobalPointer_t *TableOfElements;
} C_Record;
