/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* SHOULD BE DEFINED HERE #define MAXPARAL 10 */
static int NumberOfCollection = 0;
static char *CurrentCollectionTraversal[MAXPARAL];
static int TraversalLevel = -1;

/*******************************************************************/
/* TIMER ROUTINES */
/*******************************************************************/
#include "pcxx_timers.h"

/*******************************************************************/
int GetNumberOfCollection()
{
return NumberOfCollection;
}

/*******************************************************************/
void IncNumberOfCollection()
{
  if (NumberOfCollection >= MAXCOLLECTION)
    Message("Too many collections.",FATAL);
  NumberOfCollection++;
}

/*******************************************************************/
void SetTableOfCollection(int num,char * addr)
{
  TableOfCollection[num] = (PTR_INFO)  addr;

}

/*******************************************************************/
void SetNextCollectionTraversalLevel(char * p)
{
  TraversalLevel++;
  if (TraversalLevel >= MAXPARAL)
    Message("ResetLocal(): Too much parallelism.",FATAL);
  CurrentCollectionTraversal[TraversalLevel] = p;
}

/*******************************************************************/
char *GetCollectionTraversalLevel ()
{
  return CurrentCollectionTraversal[TraversalLevel];
}

/*******************************************************************/
void DecCollectionTraversalLevel ()
{
  TraversalLevel--;
}

/*******************************************************************/
void ResetCollectionTraversalLevel ()
{
  TraversalLevel = -1;
}

/*******************************************************************/
int pcxx_TotalNodes()
  { return MyTotalNodes; }

/*******************************************************************/
int pcxx_NodeNumber() 
  { return MyNodeNumber; }

