/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/
#ifndef __PCXX_H__
#define __PCXX_H__

#ifdef __GNUG__
  typedef int __wchar_t;
#endif

#define PCXX_FATAL 1
#define PCXX_WARNING 0
#define PCXX_FAIL -1
#define PCXX_SUCCESS 0

/* This should NOT be defined here, but makes us backwards compatible */
/* until I get all the target stuff eliminated with the new tulip stuff */
#define TULIP_FATAL 1
#define TULIP_WARNING 0

#define pcxx_Message Message

#include "pcxx-stdio.h"
#include "pcxx-string.h"
#include "pcxx-math.h"
/*  #include "pcxx-fcntl.h"  */
#include "pcxx_timers.h"

/* hacked code */
#ifndef pcxx_RemoteFunctionList
extern "C" {
  void RemoteFunctionList(void *, int, void *) {return;}
}
#endif
#endif
