/*
 *	(C) Copyright 1990
 *
 *	   The Regents of the University of California
 *			All Rights Reserved.
 *
 *	This work was produced under the sponsorship of
 *	the U.S. Department of Energy.   The Government
 *	retains certains rights therein.
 *
 *
 *	                             Notice
 *	This computer code material was prepared as an  account  of  work
 *	sponsored  by  the  United States Government.  Neither the United
 *	States nor the United States Department of  Energy,  nor  any  of
 *	their employees, nor any of their contractors, subcontractors, or
 *	their employees, makes any warranty, express or implied,  or  as-
 *	sumes  any  legal  liability  or responsibility for the accuracy,
 *	completeness or usefulness of any information, apparatus, product
 *	or  process  disclosed,  or represents that its use would not in-
 *	fringe privately-owned rights.
 *
 */
/*  MPCI PCP lock routine   */
#include "pcplib.h"

void simple_lock(lockptr)
     int *lockptr;
{
	register short	got_lock = 0,
			backoff = 0;
	register int	memval;

	while(! got_lock) {
		if ((memval = xmemi(lockptr, 1)) != 0) {
			backoff += 1;
			waitspin(backoff);
			/* someone else may grab lock before we can -
			 * be sure to check what the atomic op says WAS there */
			continue;
		}
		else
			got_lock = 1;
	}
}
