/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/*********************************************************************/
/*                Parallel run-time library                          */
/*                                                                   */
/*                Network DMA                                        */
/*                                                                   */
/* Contributions to this module have been made by:                   */
/*                                                                   */
/*     Pete Beckman *** Francois Bodin *** Dennis Gannon             */
/*                Bernd Mohr *** Shelby Yang                         */
/*********************************************************************/

/*****************************/
/* System Includes           */
/*****************************/
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

/*****************************/
/* Our Include Files         */
/*****************************/
#include "pcxx_machines.h"

/*****************************/
/* Module Global Variables   */
/*****************************/
int MyNodeNumber, MyTotalNodes;

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/
/* GENERAL FUNCTIONS */
/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

/*******************************************************************/
int tulip_NumContexts()
{ return MyTotalNodes; }

/*******************************************************************/
int tulip_MyContext() 
{ return MyNodeNumber; }

