/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1994                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/*********************************************************************/
/* Sameer Shende. Ariadne Event based debugger Event types. 	     */
/*********************************************************************/

#ifndef __PCXX_ARIADNE__H__
#define __PCXX_ARIADNE__H__

/* For AVE Trace file mtag */
#define PCXX_AA_MTAG_READ	0	/* Trace file message tag R */
#define PCXX_AA_MTAG_WRITE	1	/* Trace file message tag W */
#define PCXX_AA_MTAG_MCAST	2	/* Trace file message tag M */
#define PCXX_AA_MTAG_USER	3	/* Trace file message tag U */

/* sneezy events */
#define PCXX_error                   0      
#define PCXX_thread_terminate        1
#define PCXX_create_collection       2
#define PCXX_delete_collection       3
#define PCXX_begin_barrier           4
#define PCXX_end_barrier             5
#define PCXX_begin_fetch             6
#define PCXX_end_fetch               7
#define PCXX_begin_put               8
#define PCXX_end_put                 9
#define PCXX_begin_rpc              10
#define PCXX_end_rpc                11
#define PCXX_begin_parallel         12
#define PCXX_enter_element          13
#define PCXX_exit_element           14
#define PCXX_begin_service_rpc      15
#define PCXX_end_service_rpc        16
#define PCXX_user_event             17
#define PCXX_begin_create_collection 18
#define PCXX_end_create_collection   19
#define PCXX_begin_delete_collection 20
#define PCXX_end_delete_collection   21
#define PCXX_end_parallel            22
#endif
