/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


void classifyStatements(SgFile *f){
  SgStatement *line;
  SgStatement *s;

  s = f->firstStatement();
  for (line = s; line; line = line->lexNext()){
         switch(line->variant(){
         
/*
int isVectorStmt(SgStatement *s){
  if(isSgAssignStmt(s){
	if(findVectorRef(s->lhs()) || findVectorRef(s->rhs()))
*/		
        
void fileConvertVectToLoops(SgFile *f){
  SgStatement *line;
  SgStatement *s;

  s = f->firstStatement();
  for (line = s; line; line = line->lexNext()){
	if(isVectorStmt(line)){
                  printf("building loop for:
                  line->unparsestdout();
		}
    }

} 

void convertVectOpsToLoops(SgProject *project){

  for (int i = 0; i < project->numberOfFiles(); i++) {
    SgFile *f;
    SgPointerType *p;
    SgSymbol *symb;
    f = &(project->file(i));

    fileConvertVectToLoops(f);
    /*
    f->unparsestdout();
    f->saveDepFile("debug.dep");
    */
    }

}
main(int argc, char **argv){

  SgProject project("x.proj");
  SgFile file("x.f");
  int c;

  switch (file.languageType()) {
  case CSrc:
         printf("this is a c program.  this example is for fortran \n");
    exit(-1);
  case ForSrc:
      convertVectOpsToLoops(&project);
      // ProjectUnparse(&project);
  }
}
