extern ABSTRACT_EVENT_LIST *get_all_sibling (ABSTRACT_EVENT *ae);
extern void append_to_list (ABSTRACT_EVENT_LIST **head,  ABSTRACT_EVENT_LIST *new);
extern ABSTRACT_EVENT_LIST *get_named_nodes (char *name, ABSTRACT_EVENT *context, int i) ;
extern COLLAPSE_NODE *get_collapse_part 
  (char *name, ABSTRACT_EVENT *context, int i);
extern COLLAPSE_NODE *Get_Collapse_Part (SYN_TREE_LIST *stl, ABSTRACT_EVENT *context);
extern void add_to_list (ABSTRACT_EVENT *ae, ABSTRACT_EVENT_LIST **ael);
extern void GetPointers (ABSTRACT_EVENT *ae, char *dest, ABSTRACT_EVENT_LIST **ael,
		  int flag);
extern int get_pid (ABSTRACT_EVENT *ae, char *name);
extern ATTRIBUTE *allocate_attribute (char *name);
extern void AttachAttribute (IDENT *mvar, char *dest, 
		      char *attr, SYN_TREE_LIST *stl);
extern LINKED_LIST *get_attr_value (ABSTRACT_EVENT *ae, char *name);
extern ATTRIBUTE *get_attribute_with_name (ABSTRACT_EVENT *ae, char *aname);
extern ABSTRACT_EVENT_LIST *GetTailPointer();
extern ABSTRACT_EVENT *allocate_abstract_event (char *orig, char *name, char *marker,
						ABSTRACT_EVENT *parent_node);

extern void append_to_sibling_abstract_event
(ABSTRACT_EVENT **ths_ae, ABSTRACT_EVENT *nxt_ae);

extern ABSTRACT_EVENT_LIST *allocate_abstract_list (ABSTRACT_EVENT *ae);
extern ABSTRACT_EVENT_LIST *evaluate_abstract_list 
  (SYN_TREE_LIST *stl, ABSTRACT_EVENT *context);
extern void *apply_attr (void *ael, void *str);
extern ABSTRACT_EVENT *get_element_from_abstract_list 
(ABSTRACT_EVENT_LIST *Ael,  int pos);
extern void free_abstract_event_list (ABSTRACT_EVENT_LIST *ll);
extern CORE_SET_OBJ *get_process_set_of_abstract_event (ABSTRACT_EVENT *ae);
extern CORE_SET_OBJ *get_process_set_of_abstract_event_list 
(ABSTRACT_EVENT_LIST *ael);
extern COLLAPSE_NODE *allocate_collapse_node();
extern void abstract_list_concat 
  (ABSTRACT_EVENT_LIST **head,  ABSTRACT_EVENT_LIST *new);

