#include <stdio.h>
#include "structs.h"
#include "scan.h"

int error_check_for_identifier(IDENT *id, char *name)
{
  if (id == NULL) {
    printf("%s is not a macth variable\n", name);
    return 0;
  }
  if (id->id_decl == NULL) {
    printf("%s has not current declaration\n", name);
    return 0;
  }
}


    
boolean check_error(char *name, DECL_KIND decl_kind)
{
  IDENT   *id = id_find(name);
  DECL_KIND dk;
  if (id == NULL) {
    printf ("%s is not declared in this session.\n",name);
    return FALSE_;
  }

  if (id->id_decl == NULL && id->id_reserved != 1) {
    printf ("%s undefined: Undefined identifiers cannot be valid rvalue.\n",
	     name);
    printf ("Coarse of Action: May need to edit ave.init.file\n");
    return FALSE_;
  }
  if (id->id_decl)
    dk = id->id_decl->decl_kind;
  else
    dk = DeclUnknown;
  switch (decl_kind)
    {
    case DeclChain:
      if ((id->id_reserved != 1) && (dk != DeclChain)) {
	printf(	"%s is neither a chain nor a primitive event.\n", name);
	return FALSE_;
      }
      break;
    case DeclTchain:
      if ( (dk != DeclPchain) && (dk != DeclTchain) ) {
	printf("Ptchain is a composition of pchains or other ptchains.\n");
/*sprintf(terse_feedback, "%s is neither a pchain nor a ptchain\n", name); */
	return FALSE_;
      }
      break;
    }
  return TRUE_;
}
