/*********************************************************************
 * Access Method Macros:  Use these Lad! Not the fields themselves!  *
 *********************************************************************/

#define PID(ec) 	((ec)->myid)
#define OID(ec) 	((ec)->otherid)
#define LTIME(ec) 	((ec)->ltime)
#define EventType(ec) 	((ec)->event_type)
#define EventTag(ec) 	((ec)->event_tag)
#define MsgID(ec)       ((ec)->msg_id)
#define PhaseName(ec)   ((ec)->event_tag)
#define PhaseIteration(ec) ((ec)->msg_id)


#define Active(ec)      ((ec)->active)
#define Filter(ec)      ((ec)->filtered)
#define SoSet(ec)    ((ec)->so_set)
#define PrevEvent(ec)   ((ec)->prev)
#define NextEvent(ec)   ((ec)->next)


#define ERROR(ce)   ((ce)->error)


#define HashEventFunc(ec) (MsgID(ec) % 119771)

extern EVENT *allocate_event();
extern int get_event_logical_time (EVENT *ep);
extern void set_event_logical_time (EVENT *ep, int value);
extern int get_event_breakpoint_flag (EVENT *ep);
extern void set_event_breakpoint_flag (EVENT *ep, int value);
extern int get_event_breakpoint_cut (EVENT *ep);
extern void set_event_breakpoint_cut (EVENT *ep, int value);
extern EVENT *get_event_next (EVENT *ep);
extern EVENT *get_event_prev (EVENT *ep);
extern EVENT_TYPE EnumType(EVENT *ep);
extern char *get_event_name (EVENT *ep);
extern char *get_event_type (EVENT *ep);
extern EVENT_PTR_LIST *allocate_event_ptr_list (EVENT *ep);
