typedef union {
  int 	     ival;	      /* INTEGER literals */
  IDENT	     *id;	      /* identifiers (points to identifier 
				 table entry) */
  IDE        *ide;
  IDLIST     *id_list;
  SET_OBJ    *sobj;
  TREE_OBJ   *tobj;
  char       *str;
  SYN_TREE   *st;
  DEF_LIST   *dfl;
  SYN_TREE_LIST *stl;
  ABSTRACT_EVENT_LIST *ael;
  ON_KIND    onkind;
  OPER       op;
  WRT_LIST   *wrt;
  ExprOper   eop;
} YYSTYPE;
#define	INT_	258
#define	ID_	259
#define	_ID	260
#define	ABS_	261
#define	ADD_	262
#define	AFTER_	263
#define	AND_	264
#define	BEFORE_	265
#define	BEGIN_	266
#define	BREAK_	267
#define	BY_	268
#define	CHAIN_	269
#define	CHILD_	270
#define	COMPUTE_	271
#define	CONST_	272
#define	COUNT_	273
#define	CREATE_	274
#define	CROSS_	275
#define	DISJOINT_	276
#define	DISTINCT_	277
#define	DUMP_	278
#define	END_	279
#define	EQUAL_	280
#define	EVENT_	281
#define	EXEC_	282
#define	EXPLAIN_	283
#define	FIF_	284
#define	FIRST_	285
#define	FLOAT_	286
#define	FOR_	287
#define	FOREACH_	288
#define	GEC_	289
#define	GTC_	290
#define	IMAP_	291
#define	IN_	292
#define	INFO_	293
#define	INTEGER_	294
#define	LAST_	295
#define	LEAF_	296
#define	LEC_	297
#define	LEFT_	298
#define	LOAD_	299
#define	LTC_	300
#define	MARKER_	301
#define	MATCH_	302
#define	MLC_	303
#define	MRC_	304
#define	ONALL_	305
#define	ONSOME_	306
#define	OPTION_	307
#define	OR_	308
#define	OWNERS_	309
#define	PARENT_	310
#define	PART_	311
#define	PCHAIN_	312
#define	PRINT_	313
#define	PRODUCT_	314
#define	QUIT_	315
#define	RELATION_	316
#define	REMAINDER_	317
#define	REMOVE_	318
#define	REPORT_	319
#define	RESET_	320
#define	RESTORE_	321
#define	RIGHT_	322
#define	SECTION_	323
#define	SET_	324
#define	SHOW_	325
#define	SIBLING_	326
#define	SIF_	327
#define	SIZE_	328
#define	SOURCE_	329
#define	SUM_	330
#define	SUBSET_	331
#define	SUPERSET_	332
#define	TCHAIN_	333
#define	TO_	334
#define	UNION_	335
#define	UTAG_	336
#define	VIEW_	337
#define	WITH_	338
#define	WRT_	339
#define	DOTDOT_	340
#define	COLON_COLON_	341
#define	COLON_EQ_	342
#define	PUSH_	343
#define	POP_	344
#define	AT_	345
#define	NOT_	346
#define	LE_	347
#define	GE_	348


extern YYSTYPE yylval;
