#define CoreSetDim(core) core->dim
#define CoreSetSize(core) core->size
#define CoreSetTail(core) core->tail
#define CoreSetNthElem(core,n) core->elem[(n)]
#define CoreSetElem(core) core->elem
#define CoreSet(x) x->core
#define SetName(x) x->name


extern CORE_SET_OBJ *allocate_core_set_object();
extern int *allocate_set_element(int pos, int dim);
extern CORE_SET_OBJ *get_core_set_union (CORE_SET_OBJ *s1, CORE_SET_OBJ *s2);
extern CORE_SET_OBJ *get_core_set_section (CORE_SET_OBJ *s1, CORE_SET_OBJ *s2);
extern CORE_SET_OBJ *get_core_set_direct_product (CORE_SET_OBJ *s1, CORE_SET_OBJ *s2);
extern CORE_SET_OBJ *get_set_union (SET_OBJ *s1, SET_OBJ *s2);
extern CORE_SET_OBJ *get_set_section (SET_OBJ *s1, SET_OBJ *s2);
extern CORE_SET_OBJ *get_set_direct_product (SET_OBJ *s1, SET_OBJ *s2);
extern SET_OBJ *allocate_set();
extern boolean inter_set (SET_OBJ *so);
extern SET_OBJ *replicate_set_object (SET_OBJ *so);

extern void free_core_set_object (CORE_SET_OBJ *so);
extern CORE_SET_OBJ *make_core_set (INT_LINKED_LIST *il);
extern INT_LINKED_LIST 
  *get_intersection_in_list (INT_LINKED_LIST *left, INT_LINKED_LIST *right);
extern INT_LINKED_LIST 
  *get_union_in_list (INT_LINKED_LIST *left, INT_LINKED_LIST *right);
extern INT_LINKED_LIST 
  *get_cross_product_in_list (INT_LINKED_LIST *left, INT_LINKED_LIST *right);
INT_LINKED_LIST *get_int_list_from_set (CORE_SET_OBJ *cso);
