/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


# define pCC_NUMEVENTS 90

static char *edfFooter[] = {
"",
"# Software event tracer events ---------------------------",
"60000 -         0 ev_init                       eventclass",
"60001 TRACE   -10 ev_flush-enter                numrecords",
"60002 -        -9 ev_flush-exit",
"60003 -         0 ev_close",
"60004 -         0 ev_initM                      eventclass",
"60005 -         0 ev_wall_clock                  wallclock",
"60006 -         0 ev_cont_event                           ",
"",
"# pC++ kernel timer events -------------------------------",
"60199 -         0 wtimer-clear",
"60100 -         0 wtimer0-start",
"60101 -         0 wtimer1-start",
"60102 -         0 wtimer2-start",
"60103 -         0 wtimer3-start",
"60104 -         0 wtimer4-start",
"60105 -         0 wtimer5-start",
"60106 -         0 wtimer6-start",
"60107 -         0 wtimer7-start",
"60108 -         0 wtimer8-start",
"60109 -         0 wtimer9-start",
"",
"60200 -         0 wtimer0-stop",
"60201 -         0 wtimer1-stop",
"60202 -         0 wtimer2-stop",
"60203 -         0 wtimer3-stop",
"60204 -         0 wtimer4-stop",
"60205 -         0 wtimer5-stop",
"60206 -         0 wtimer6-stop",
"60207 -         0 wtimer7-stop",
"60208 -         0 wtimer8-stop",
"60209 -         0 wtimer9-stop",
"",
"60399 -         0 utimer-clear",
"60300 -         0 utimer0-start",
"60301 -         0 utimer1-start",
"60302 -         0 utimer2-start",
"60303 -         0 utimer3-start",
"60304 -         0 utimer4-start",
"60305 -         0 utimer5-start",
"60306 -         0 utimer6-start",
"60307 -         0 utimer7-start",
"60308 -         0 utimer8-start",
"60309 -         0 utimer9-start",
"",
"60400 -         0 utimer0-stop",
"60401 -         0 utimer1-stop",
"60402 -         0 utimer2-stop",
"60403 -         0 utimer3-stop",
"60404 -         0 utimer4-stop",
"60405 -         0 utimer5-stop",
"60406 -         0 utimer6-stop",
"60407 -         0 utimer7-stop",
"60408 -         0 utimer8-stop",
"60409 -         0 utimer9-stop",
"",
"# pC++ runtime system events -----------------------------",
"61100 RTS     -11 setup-enter                      numproc",
"61101 -         0 setup-init",
"61102 -        -9 setup-exit                       numproc",
"61103 RTS     -12 fork-enter",
"61104 -        -9 fork-exit",
"61105 RTS     -13 newproc-enter",
"61106 -        -9 newproc-exit                      procid",
"61107 WAIT    -14 barrier-enter",
"61108 -        -9 barrier-exit",
"61109 WAIT    -15 poll-enter",
"61110 -        -9 poll-exit",
"61111 -         0 dealloc-enter                    address",
"61112 -         0 dealloc-exit",
"61113 -        -7 coll_acs-start                 from_proc",
"61114 -        -8 coll_acs-end                   from_proc",
"",
"61120 RTS     -16 main-enter",
"61121 -        -9 main-exit",
"",
"61122 -         0 usercode-enter",
"",
"61150 -         0 instl_coll                      coll_num",
"61151 -         0 coll_info_1                      num_dim",
"61152 -         0 coll_info_2                     sizeelem",
"61153 -         0 coll_info_3                      nb_elem",
"61154 -         0 coll_info_4                     dim1size",
"61155 -         0 coll_info_5                     dim2size",
"61156 -         0 elem_info                       elem_num",
"61157 -         0 elem_access                   elem_ident",
"",
"61170 -         0 ev_sync_mark",
"61177 -         0 ariadne_ipc                   msg_id",
"61178 -         0 ariadne_pcxx_ev               ev_par",
"",
"# TC2000 pC++ runtime system events ----------------------",
"61200 -         0 fork_first",
"61201 -         0 fork_rest",
"61202 -         0 fork_setclass",
"61203 -         0 fork_complete",
"61204 -         0 attach-call",
"61205 -         0 attach-return",
"61206 -         0 jobcntl-call",
"61207 -         0 alloc_procs-call",
"61208 -         0 alloc_heapm-call",
"61209 -         0 fork-kill",
"",
"# KSR1 pC++ runtime system events ------------------------",
"61210 -         0 fork_fork                      numforked",
"61211 -         0 fork_join                      numforked",
"61212 -         0 fork_bind                         cellid",
"61213 -         0 in_barrier                    numarrived",
NULL
};
