/* c l i e n t - r e p l y . h
 * $Id: client-reply.h,v 1.1 1996/05/01 20:09:41 lth Exp $
 *
 * Copyright (C) 1995 The University of Oregon.
 *
 *   Author: Lars Thomas Hansen [lth@cs.uoregon.edu]
 *  Created: November 20, 1995
 * Modified:
 *
 * Reply management.
 */

#if defined(SERVER_SIDE) || !defined(CLIENT_SIDE)
#error "reply.h valid on client side only."
#endif

#ifndef INCLUDED_REPLY
#define INCLUDED_REPLY

#ifdef __cplusplus
extern "C" {
#endif

void 
dispatch_read_request( snz_conn_t *c, int cid, int tid, snz_addr_t p,
		       int len, 
		       int (*f)( snz_conn_t *c, int cid, int tid, void *b ) );
int snz_reply( snz_conn_t *c, int cid, int tid, void *d );

#ifdef __cplusplus
}
#endif

#endif /* ifndef INCLUDED_REPLY */

/* eof */

