/* p c x x . c
 * $Id: pcxx.c,v 1.1 1996/05/01 20:09:48 lth Exp $
 *
 * pC++ RTS specific support for SPMD. 
 */

#define SERVER_SIDE

#include <stdlib.h>
#include "sneezy.h"
#include "server-types.h"

void _snz_spmd_terminate_thread( void )
{
  exit( 1 );
}

int _snz_spmd_nodenumber( void )
{
  return pcxx_NodeNumber();
}

int _snz_total_nodes()
{
  return pcxx_TotalNodes();
}

snz_time_t _snz_get_time( void )
{
  return pcxx_get_time();
}

void *_snz_allocbuf( int len )
{
  void *p = malloc( len );
  if (p == 0)
    snz_perror_panic( "malloc" );
  return p;
}

void _snz_freebuf( void *buf )
{
  free( buf );
}

/* eof */
