/* s e r v e r - t y p e s . h
 * $Id: server-types.c,v 1.1 1996/05/01 20:10:01 lth Exp $
 *
 * Copyright (C) 1995 The University of Oregon.
 *
 *   Author: Lars Thomas Hansen [lth@cs.uoregon.edu]
 *  Created: November 28, 1995
 * Modified:
 *
 * Server type abstraction manipulation.
 */

#define SERVER_SIDE

#include <stdio.h>
#include "server-types.h"

/* There is no portable output for %p so we have to do our own. Sigh. */
void snz_ptr2str( snz_addr_t p, char *buf )
{
  sprintf( buf, "#x%lx", (long)(void*)p );
}

long snz_str2long( char *s )
{
  long l;

  if (*s == '#' && *(s+1) == 'x')
    sscanf( s+2, "%lx", &l );
  else
    sscanf( s, "%ld", &l );
  return l;
}

/* eof */
