/* s e r v e r - t y p e s . h
 * $Id: server-types.h,v 1.1 1996/05/01 20:10:02 lth Exp $
 *
 */

#if !defined(SERVER_SIDE) || defined(CLIENT_SIDE)
#error "Server-types.h valid on server side only."
#endif

#ifndef INCLUDED_SERVER_TYPES
#define INCLUDED_SERVER_TYPES

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char _octet;
typedef int snz_int_t;
typedef long snz_long_t;
typedef void * snz_addr_t;

typedef struct _snz_arg_t snz_arg_t;

typedef struct snz_gptr_t snz_gptr_t;

struct snz_gptr_t {
  int        context;   /* context number */
  snz_addr_t addr;      /* global pointer */
};

typedef double snz_time_t;   /* FIXME: not right. */
#define TIME_IS_DOUBLE

typedef struct {
  int length;
  _octet *data;
} snz_str_t;

long snz_str2long( char *s );

void snz_ptr2str( snz_addr_t, char * );

#define SNZ_PTR_CHARS_MAX  23  /* (+ 3 (ceiling (log10 (expt 2 64)))) */

/* FIXME: operations */

#ifdef __cplusplus
}
#endif

#endif /* ifndef INCLUDED_SERVER_TYPES */

/* eof */
