/* s o c k e t . h
 * $ID$
 *
 * Copyright (C) 1995 The University of Oregon
 *
 *   Author: Lars Thomas Hansen [lth@cs.uoregon.edu]
 *  Created: November 20, 1995
 * Modified: January 24, 1996 / lth -- read_bytes and write_bytes.
 *
 * Socket abstraction.
 */

#define RDY_TRIVIAL 0
#define RDY_ANY 1

int open_server_socket( int *portno, int *outfd );
int accept_connection( int fd );
int connect_to_server( char *addr, int portno );
char *myaddr( void );
int ready( FILE *, int );
int read_bytes( int fd, void *buf, int len );
int write_bytes( int fd, void *buf, int len );

/* eof */
