#include <stdio.h>
#include <stdlib.h>
#include "Trace.h"

void PrintTrace(FILE *file)
{
  Crt_Event_t event;

  event.par = new long int[MAX_PAR];
  fprintf(stdout, "Time      Event_id     Event_name     Thread_id    Data\n"); 
  while (!ReadCrtEvent(file, &event))
    PrintCrtEvent(&event);
}

main(int argc,char **argv)
{
  char *trace_base;
  FILE *trace_file;

  trace_base=GetBaseName(argc,argv);
  trace_file=OpenTraceFile(trace_base, TRACE_TYPE_CRT, 
                           TRACE_NO_SUBSCRIPT, TRACE_READ);
  InitEventNamesDB();
  PrintTrace(trace_file);

  return 0;
}
