#define SEMAPHORE_C

#include <task.h>
#include "Semaphore.h"

void Semaphore::signal()
{
  if (sigs++ == 0) alert();
  return;
}

int Semaphore::waitNoBlock()
{
  if (sigs <= 0) return 0;
  sigs--;
  return 1;
}

void Semaphore::wait()
{
  for(;;) {
    if (--sigs >= 0) return;
    sigs++;
    thistask->sleep(this);
  }
}

#undef SEMAPHORE_C

