#ifndef MSG_H
#define MSG_H

#define REAL 0
#define IMAG 1

#define NOTAMSG 0
#define REQUESTMSG 1
#define REPLYMSG 2
#define BARRIERENTRYMSG 3
#define BARRIEREXITMSG 4

class Msg_c {
 private:
  int MsgCat;
  int MsgType;
  int MsgSize;
  int FromNodeId;
  int ToNodeId;
  int MsgPar;
  Msg_c *NextMsg;
 public:
  Msg_c(int cat, int type, int size, int from, int to, int par);
  Msg_c();

  int GetMsgCat()                { return MsgCat; };
  int GetMsgType()               { return MsgType; } ;
  int GetMsgSize()               { return MsgSize; } ;
  int GetFromNodeId()            { return FromNodeId; } ;
  int GetToNodeId()              { return ToNodeId; } ;
  int GetMsgPar()                { return MsgPar; };
  Msg_c *GetNextMsg()            { return NextMsg; };
  void SetMsgCat(int cat)        { MsgCat = cat; };
  void SetMsgType(int type)      { MsgType = type;} ;
  void SetMsgSize(int size)      { MsgSize = size;} ;
  void SetFromNodeId(int from)   { FromNodeId = from; };
  void SetToNodeId(int to)       { ToNodeId = to; };
  void SetMsgPar(int par)        { MsgPar = par; };
  void SetNextMsg(Msg_c * msg)   { NextMsg = msg;} ;
};


#ifndef MSG_C
#endif

#endif

