#define STATISTICS_C
#include "Trace.h"
#include "TaskLibIncludes.h"
#include "SimulatorIncludes.h"

Statistics_c::Statistics_c(System_c *sys, int num)
{
  char filename[256];

  Sys = sys;
  NumberOfThreads = num;
  sprintf(filename, "%s.stat", StatFileName);
  Fpstat = fopen(filename, "w");
  if (Fpstat == NULL) {
    fprintf(stderr, "Unable to open %s\n", filename);
    exit(1);
  }
}

void Statistics_c::PrintAll()
{
  fprintf(Fpstat, "NumberOfThreads: %d\n", NumberOfThreads);
  fprintf(Fpstat, "Timer1Time: %lf\n", Timer1Time);
  fprintf(Fpstat, "ForkTime: %lf\n", ForkTime);
  fprintf(Fpstat, "SimTime: %lf\n", SimTime);
  fprintf(Fpstat, "SelectedTime: %lf\n", SelectedTime);
}
#undef STATISTICS_C

