#ifndef STATISTICS_H
#define STATISTICS_H

class System_c;

class Statistics_c {
  private:
   System_c *Sys;
   FILE *Fpstat;
   int NumberOfThreads;
   double SimTime;  /* time for simulation */
   double Timer1Time; /* timer1 time */
   double ForkTime; /* time between fork_enter and fork_exit */
   double SelectedTime; /* time between on/off events */
  public:
   Statistics_c(System_c *s, int num); 
   void SetSimTime(double t)  { SimTime = t; };
   void SetTimer1Time(double t) { Timer1Time = t; };
   void SetForkTime(double t) { ForkTime = t; };
   void SetSelectedTime(double t) { SelectedTime = t; };
   void PrintAll();
};

#endif
