
      SUBROUTINE IOALL(IWHAT,JDIM,KDIM,Q,PRESS,SNDSP,XY,XYJ,X,Y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      PARAMETER (MAXJ=289, MAXK=89, MAXJK=MAXJ*MAXK  )
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CPUSEC,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    JACDT,    RESID,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4)
      DIMENSION PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM)
C
      COMMON/WORKSP/CPBOD(MAXJ),XBOD(MAXJ), WORK2(MAXJ,90)
C
      COMMON/IO/IREAD,IWRIT,IVER
C
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17) IWHAT
C
    1 CONTINUE
      OPEN(UNIT=4, FILE='SRO4',STATUS='NEW', FORM='UNFORMATTED')
      WRITE(4) JMAX,KMAX
      WRITE(4) FSMACH,ALPHA,FSMACH,ALPHA
      WRITE(4) ( ( ( Q(J,K,N)*XYJ(J,K),J=1,JMAX) ,K=1,KMAX) ,N=1,4)
      WRITE(4) JTAIL1, NUMITE 
      REWIND 4
C
      GO TO 10000
C
C
C***********************************************************************
C
    2 CONTINUE
      GO TO 10000
C
C**********************************************************************
C
C
    3 CONTINUE
C
C
      GO TO 10000
C
C
C***********************************************************************
C          READ THE RESTART
C
    4 CONTINUE
C
C      READ IN A UNFORMATTED RESTART FILE FROM TAPE3.
C      THE Q READ IN IS NOT YET SCALED BY THE METRIC JACOBIAN XYJ,
C      THE RESCALING IS DONE IN INITIA.
C
C  CHANGED TO BE COMPATIBLE WITH  NEW PLOT3D  4/2/86
C
      OPEN(UNIT=3, FILE='SRI3',STATUS='OLD', FORM='UNFORMATTED')
      READ(3) JMAX2,KMAX2
      READ(3) FSMTEM,ALPTEM,RETEM,TOTIME
C
      WRITE(IWRIT, 433) TOTIME, ISTART
  433 FORMAT(1H0,12HTOTAL TIME =,F12.6,
     1       10X, 20HSTARTING ITERATION =, I5)            
C
      READ(3) ( ( ( Q(J,K,N),J=1,JMAX2) ,K=1,KMAX2) ,N=1,4)
      READ(3) JTITEM, ISTART

      WRITE(3) ( ( ( Q(J,K,N),J=1,JMAX2) ,K=1,KMAX2) ,N=1,4)
      WRITE(3) JTITEM, ISTART
C
      GO TO 10000
C
C
C***********************************************************************
C          ITERATION NUMBER AND RESIDUAL WRITTEN TO OUTPUT
C
    5 CONTINUE
      GO TO 10000
C
C
C***********************************************************************
C          COEFFICIENT OF PRESSURE DATA WRITTEN TO OUTPUT
C
    6 CONTINUE
C
C
      WRITE(IWRIT, 666)
666   FORMAT( 1X, 23HCOEFFICIENT OF PRESSURE )
      CPC = 2./(GAMMA*FSMACH**2)
C   COMPUTE CP AT GRID POINTS AND STORE IN Z ARRAY
      DO 665 J=JTAIL1,JTAIL2
         WRITE(IWRIT, 667) J, X(J,1), CP
665   CONTINUE
C
667   FORMAT( 1X, I5, 5X, F14.7, 5X, F14.7)
C
C
      GO TO 10000
C
C***********************************************************************
   7    CONTINUE
      GO TO 10000
C
C***********************************************************************
C
    8 CONTINUE
C
      GO TO 10000
C
C
C***********************************************************************
C
    9 CONTINUE
C
      GO TO 10000
C
C
C***********************************************************************
C          STORE A UNFORMATTED RESTART FILE
C
   10 CONTINUE
C
C     NOTE THAT NUMITE  IS ACTUALLY ONE GREATER THAN THE LAST USED.
C     IT GETS STORED, AND USED AS THE FIRST ITERATION NEXT TIME.
C
C       REWIND BECAUSE THIS MAY BE CALLED PERIDC  ALLY
      OPEN(UNIT=4, FILE='SRO4',STATUS='NEW', FORM='UNFORMATTED')
      WRITE(4) JMAX,KMAX
      WRITE(4) FSMACH,ALPHA,FSMACH,ALPHA
      WRITE(4) ( ( ( Q(J,K,N)*XYJ(J,K),J=1,JMAX) ,K=1,KMAX) ,N=1,4)
      WRITE(4) JTAIL1, NUMITE 
      REWIND 4
C
      GO TO 10000
C
C***********************************************************************
C
   11 CONTINUE
      GOTO 10000
C***********************************************************************
C
   12 CONTINUE
      GOTO 10000
C***********************************************************************
   13 CONTINUE
      GOTO 10000
C***********************************************************************
C***********************************************************************
   14 CONTINUE
      GOTO 10000
C***********************************************************************
C***********************************************************************
C
   15 CONTINUE
C
C
C    OUTPUT ON TAPE6 9 VARIABLES ALONG THE BODY
C
      K = 1
      WRITE(IWRIT,  1510) K
1510  FORMAT( 1X, 4HK = , I4 )
      WRITE(IWRIT, 1515)
1515  FORMAT( 1X,
     1   51H  J   K     RHO            U             V           ,
     2   25HENERGY      PRESSURE     ,
     3   42H COEFF P    LOCAL MACH     X             Y )           
C
      DO 1590 J = 1, JMAX
         RHO = Q( J, K, 1) * XYJ( J, K)
         U = Q( J, K, 2) / Q( J, K, 1)
         V = Q( J, K, 3) / Q( J, K, 1)
         UVSQ = U**2 + V**2
         ENERGY = Q( J, K, 4) * XYJ( J, K)
         PPP = PRESS(J,K)*XYJ(J,K)
         CPC = 2./(GAMMA*FSMACH**2)
         CP = (PPP * GAMMA - 1. ) * CPC
         CSQ = SNDSP(J,K)
         EMACH = SQRT( UVSQ )/ CSQ 
         XCOORD = X( J, K)
         YCOORD = Y( J, K)
         WRITE(IWRIT, 1520) J, K, RHO, U, V, ENERGY, PPP,
     1      CP, EMACH, XCOORD, YCOORD
1520     FORMAT( 1X, 2( I3, 1X), 9( F11.6, 2X ) )
1590   CONTINUE
C
       GOTO 10000
C
C***********************************************************************
C***********************************************************************
C          GRID OUTPUT
C
   16 CONTINUE
C
      OPEN(UNIT=11, FILE='SRO11',STATUS='NEW', FORM='UNFORMATTED')
      WRITE( 11) JMAX,KMAX
      READ( 11)  ( ( X(J,K),J=1,JMAX) ,K=1,KMAX) ,
     &             ( ( Y(J,K),J=1,JMAX) ,K=1,KMAX)
      WRITE( 11)  ( ( X(J,K),J=1,JMAX) ,K=1,KMAX) ,
     &             ( ( Y(J,K),J=1,JMAX) ,K=1,KMAX)
C
C
      GO TO 10000
C
C
C***********************************************************************
C***********************************************************************
C          COMPUTE CIRCULATION, AND PRINT IT OUT ( NOT IN COMMON )
C
   17 CONTINUE
C
C
      GO TO 10000
C
C
C***********************************************************************
C
C
10000 RETURN
      END
