
ccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc   Use NODES processors and create a merger from 
ccc   each node to the master node.  Each node sends 
ccc   an integer on its outport to the merger and the 
ccc   master node sums the integers.  If the proper 
ccc   sum is reached after all of the outports were 
ccc   closed then the merger is assumed to have worked 
ccc   properly.
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      program main
      parameter (nodes = 5)
      processors (nodes)
      inport (integer ) in
      outport (integer ) out(nodes)
      do  i = 1,nodes
         merger(OUT=out(i), IN=in)
      enddo
      processes
         call receive_the_data(in)
         processdo  i = 1,nodes
            process call send_data(out(i),i) location(i)
         endprocessdo
      endprocesses
      end


ccccccccccccccccccccccccccccccccccccccccccccc
      process send_data (out, id)
      integer  id
      outport (integer ) out
      intent(in) id
      send(PORT=out) id
      endchannel(PORT=out)
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccc
      process receive_the_data (in)
      parameter (nodes = 5)
      inport (integer ) in
      integer  m
      integer  accum
      accum = 0
10    continue
         receive(PORT=in, END=100) m
         accum = accum + m
         goto 10
100      if (accum .eq. int (nodes * (nodes + 1) / 2)) then
            print *,'MERGER OK.'
         else
            print *,'MERGER not ok.'
         endif
         return
      end

