/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* label type codes */

#define LABUNKNOWN	0
#define LABEXEC		1
#define LABFORMAT	2
#define LABOTHER	3


/* parser states */

#define OUTSIDE 0
#define INSIDE	1
#define INDCL	2
#define INDATA	3
#define INEXEC	4

/* nesting states */
#define IN_OUTSIDE 4
#define IN_MODULE 3
#define IN_PROC   2
#define IN_INTERNAL_PROC 1

/* Control stack type */

#define CTLIF 0
#define CTLELSEIF 1
#define CTLELSE 2
#define CTLDO 3
#define CTLALLDO 4


/* name classes -- vclass values */

#define CLUNKNOWN 0
#define CLPARAM 1
#define CLVAR 2
#define CLENTRY 3
#define CLMAIN 4
#define CLBLOCK 5
#define CLPROC 6
#define CLNAMELIST 7

/* These are tobe used in decl_stat field of symbol */
#define SOFT 0   /* Canbe Redeclared */
#define HARD 1   /* Not allowed to redeclre */

/* Attributes (used in attr) */
#define ATT_CLUSTER 0
#define ATT_GLOBAL  1

#define SECTION_SUBSCRIPT 1
