/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

extern "C" int   m_fork(void (*)(), ...);
extern "C" void  MSNewProc(void);
extern "C" void  MSFinishProc(void);
extern "C" int   pcaw_inseq;

extern "C" void New_Main()
{
  ResetCollectionTraversalLevel ();

  pcaw_inseq--;
  m_fork(MSNewProc);
  pcaw_inseq++;

  Processor_Main(0,0);

  pcaw_inseq--;
  m_fork(MSFinishProc);
  pcaw_inseq++;
}

void pcaw_EnterPar(Kernel *coll, int selector)
{
  if(coll){
    ResetLocal(coll);
  }
  pcxx_inpar++;
  pcaw_inseq--;
  m_fork((void (*)())WorkerSwitch, (void *)selector, (void *)coll);
}

void pcaw_SubsetEnterPar(Kernel *coll, int selector)
{
  pcaw_EnterPar(coll, selector);
}

void pcaw_ExitPar()
{
  pcaw_inseq++;
  pcxx_inpar--;
  ResetCollectionTraversalLevel();
}

